<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Herramientas para el diseño de interfaces.</title>
  <link rel="stylesheet" href="./css/reveal.css">
  <link rel="stylesheet" href="./css/theme/solarized.css">
  <link rel="stylesheet" href="./lib/css/zenburn.css">
  <link rel="stylesheet" href="./css/customizations.css">
</head>
<body>
  <div class="reveal">
    <div class="slides">
      <section>
        <h1>Firebase</h1>
        <img src="./img/firebase_logo.svg" class="pure-img" style="width:15%;margin-top:60px;"></img>
      </section>
      <section style="text-align: justify;">
        <h3>¿Qué es Firebase?</h3>
        <p>Firebase es una plataforma para el desarrollo de aplicaciones web y móviles.</p>
        <br>
        <p>Bases de datos disponibles con Firebase:</p>
        <ul>
          <li>Firebase Realtime Database</li>
          <li>Firebase Cloud Firestore</li>
        </ul>
      </section>
      <section>
        <h3>Firebase Cloud Firestore</h3>
        <p style="text-align: justify;">Es una base de datos NoSQL online orientada a documentos. Los datos, en lugar de organizarse en tablas y filas se almacenarán como pares clave-valor en documentos.</p>
        <img src="./img/cloud-firestore.svg" class="pure-img" style="width:20%"></img>
      </section>
      <section>
        <h3>Instalación y configuración</h3>
        <p>Firebase es un servicio en línea, por lo que no requiere instalación. Solo será necesaria una cuenta de Google.</p>
        <img src="./img/crear_proyecto.png" style="width:31%;">
      </section>
      <section>
        <h3>Estructura de Documentos</h3>
        <p style="text-align: justify;">Firebase almacena los documentos como Objetos JSON (JavaScript Object Notation).</p>
        <p style="text-align: justify;">Los documentos se organizan en Colecciones.</p>
        <p style="text-align: justify;">Cada documento puede contener datos primitivos como Strings u otras colecciones.</p>
        <img src="./img/archivo-json.svg" class="pure-img" style="width:20%"></img>
      </section>
      <section>
        <h3>Ejemplo de documento en Firebase Cloud Firestore</h3>
        <img src="./img/ejemplo_documento.png" style="width: 80%">
      </section>
      <section>
        <h3>Pros y Contras de Firebase</h3>
        <div style="margin:0 auto">
          <div style="display:inline-block;width:45%">
            <p style="text-align: left">Pros:</p>
            <ul>
              <li>Escalabilidad</li>
              <li>JSON</li>
              <li>SDKs</li>
            </ul>
          </div>
          <div style="display:inline-block;width:45%">
            <p style="text-align: left">Contras:</p>
            <ul>
              <li>Precio elevado</li>
              <li>No muy usado</li>
              <li>Consultas limitadas</li>
            </ul>
          </div>
        </div>
      </section>
      <section>
        <h3>Licencia</h3>
        <p>La licencia de Firebase es Apache 2.0</p>
        <img src="./img/apache_logo.svg" class="pure-img" style="width: 60%">
      </section>
      <section>
        <h3>Demostración</h3>
        <p>Hemos desarrollado una Aplicación de Android utilizando Firebase Cloud Firestore</p>
        <img src="./img/app.jpg" style="width:24%">
        <img src="./img/app_add.jpg" style="width:24%">
        <img src="./img/app_edit.jpg" style="width:24%">
      </section>
      <section>
        <h3>Ejemplo de consulta</h3>
        <pre><code class="hljs java" data-trim style="margin-top: 60px">
FirebaseFirestore.getInstance()
  .collection("users")
  .get()
  .addOnCompleteListener(new OnCompleteListener&lt;QuerySnapshot&gt;() {
    @Override
    public void onComplete(@NonNull Task&lt;QuerySnapshot&gt; task) {
      if (task.isSuccessful()) {
        QueryDocumentSnapshot[] documents = task.getResult();
      } else {
        System.out.println("Error getting documents!");
      }
    }
  }
);
        </code></pre>
      </section>
      <section>
        <h1>FIN</h1>
        <p>Esta presentación ha sido desarrollada con <a href="https://github.com/hakimel/reveal.js">reveal.js</a>.</p>
      </section>
    </div>
  </div>
  <script src="lib/js/head.min.js"></script>
  <script src="js/reveal.js"></script>
  <script>
    Reveal.initialize({
      history: true,
      dependencies: [
        { src: 'plugin/highlight/highlight.js', async: true, callback: function () { hljs.initHighlightingOnLoad(); } },
      ]
    });
  </script>
</body>
</html>